<template>
	<mobile-frame>
		<view class="main">
			<view class="one">
				<scroll-view scroll-y="true" class="scroll-view">
					<view class="list-scroll-view">
						<view class="one_1" @tap="toChoose">
							<text class="localicon iconfont icon-dingweixiao"></text>
							<view class="other" v-if="address._id">
								<view class="name">
									<text>{{address.name}},</text>{{address.phone}}
								</view>
								<view class="other_1">
									<text>{{address.province}}</text><text>{{address.city}}</text>
									<text>{{address.area}}</text><text>{{address.address}}</text>
								</view>
							</view>
							<view class="address" v-else><text>请选择一个收货地址</text></view>
							<text class="iconfont icon-jiantouyou"></text>
						</view>
						<view class="one_2">
							<view class="list" v-for="(item,index) in orderList" :key="index">
								<view class="list_1">
									<view class="l">
										<text class="iconfont icon-shangdian"></text>
										<text>{{item.shop_name}}</text>
									</view>
								</view>
								<view class="list_2" v-for="(tag,index) in item.goods" :key="index">
									<view class="l">
										<image class="image" :src="tag.file&&tag.file.length>0?tag.file[0].url:''" mode=""></image>
									</view>
									<view class="c">
										<view class="name">
											{{tag.goods_name}}
										</view>
										<view class="Spec">
											规格:{{tag.goodsSpec_name}}
										</view>
									</view>
									<view class="r">
										<view class="price" v-if="type=='0'">
											¥{{tag.money}}
										</view>
										<view v-else class="price">
											¥{{tag.group_sell_money}}
										</view>
										<view class="num">
											×{{tag.num}}
										</view>
									</view>
								</view>
								<view class="list_3">
									<view class="other">
										<view class="other_1">配送方式</view>
										<view class="other_2"><text class="iconfont icon-duihao"></text>快递配送</view>
									</view>
									<view class="other">
										<view class="other_1">运费</view>
										<view class="other_2" v-if="!item.freight_total==0">￥{{item.freight_total}}
										</view>
										<view class="other_2" v-else>包邮</view>
									</view>
									<view class="other">
										<view class="other_1">订单备注</view>
										<view class="other_3">
											<input type="text" v-model="item.remarks" placeholder="选填,可填写您与卖家达成一致的要求" />
										</view>
									</view>
								</view>
							</view>
							<view class="other" v-if="type=='0'">
								<view class="other_1">优惠劵</view>
								<view class="other_2" @click="toCoupon" v-if="couponList.length">
									{{coupon_name||'请选择优惠劵'}}
								</view>
								<view class="other_2" v-else>暂无优惠劵使用</view>
							</view>
						</view>
					</view>
				</scroll-view>
			</view>
			<view class="two">
				<view class="two_1">
					<view>实付金额:</view>
					<view>￥{{goods_total}}</view>
				</view>
				<view class="two_2">
					<text @tap="toSubmit">提交订单</text>
				</view>
			</view>
		</view>
		<uni-popup ref="popup" background-color="#fff" type="bottom">
			<view class="popup" v-if="popup.type=='1'">
				<scroll-view scroll-y="true" class="scroll-view">
					<discount :Style="Style" :couponList="couponList" @toDiscount="toDiscount"></discount>
				</scroll-view>
			</view>
		</uni-popup>
	</mobile-frame>
</template>

<script>
	import discount from '@/components/discount/index.vue';
	export default {
		components: {
			discount
		},
		data() {
			return {
				// 设备平台信息
				system: {},
				popup: {
					type: '1'
				},
				Style: {
					btn: true
				},
				user: {},
				key: '',
				address: {},
				orderList: [],
				shop: [],
				goods_total: 0,
				// 金额明细
				total_detail: {},
				// 收货地址
				addressList: [],
				// 优惠劵
				couponList: [],
				coupon: [],
				// 优惠劵名称
				coupon_name: '',
				// 是否开团
				type: '0',
				// 团id
				group_id: '',
				// 分享人id
				inviter: '',
			};
		},
		onLoad: function(e) {
			const that = this;
			uni.$on("id", async (id) => {
				let arr = await that.$api(`/address/${id}`, `GET`)
				if (arr.errcode == '0') {
					that.$set(that, `address`, arr.data)
				}
			})
			that.$set(that, `key`, e.key || '');
			that.$set(that, `group_id`, e.group_id || '');
			that.watchLogin()
		},
		methods: {
			// 监听用户是否登录
			watchLogin() {
				const that = this;
				uni.getStorage({
					key: 'token',
					success: function(res) {
						let user = that.$jwt(res.data);
						that.$set(that, `user`, user);
						// 设备平台信息
						let config = that.$config;
						that.$set(that, `system`, config.system);
						that.search()
					},
					fail: function(err) {
						uni.navigateTo({
							url: `/pages/login/index`
						})
					}
				})
			},
			// 查询列表
			async search() {
				const that = this;
				let user = that.user;
				const res = await that.$api(`/address`, 'GET', {
					customer: user._id
				})
				if (res.errcode == '0') {
					that.$set(that, `addressList`, res.data.reverse());
				}
				const arr = await that.$api(`/order/toMakeOrder`, 'POST', {
					key: that.key
				})
				if (arr.errcode == '0') {
					// 分享人id
					that.$set(that, `inviter`, arr.data.inviter);
					// 地址
					that.$set(that, `address`, arr.data.address);
					// 订单
					that.$set(that, `orderList`, arr.data.goodsData);
					// 总价
					that.$set(that, `total_detail`, arr.data.orderTotal);
					that.$set(that, `type`, arr.data.type);
					this.computedTotal();
					// 优惠劵
					that.$set(that, `couponList`, arr.data.couponList);
				}
			},
			// 使用优惠劵
			toDiscount(e) {
				const that = this;
				that.$set(that, 'coupon_name', e.name)
				that.coupon.push(e._id)
				that.$refs.popup.close();
				this.computedTotal();
			},
			// 选择收货地址
			toChoose() {
				const that = this;
				if (that.address?._id) {
					uni.navigateTo({
						url: `/pagesMy/address/index?type=${"shopping"}&id=${that.address._id}`
					})
				} else {
					uni.navigateTo({
						url: `/pagesMy/address/index?type=${"shopping"}`
					})
				}
			},
			// 选择优惠劵
			toCoupon() {
				const that = this;
				that.$set(that.popup, 'type', '1')
				that.$set(that, 'coupon', [])
				that.$refs.popup.open();
			},
			// 提交订单
			async toSubmit() {
				const that = this;
				let system = that.system;
				if (that.address) {
					let obj = {
						address: that.address,
						goods: that.orderList,
						total_detail: that.total_detail,
						coupon: that.coupon,
						type: that.type,
						inviter: that.inviter
					}
					if (that.group_id) obj.group = that.group_id;
					// 创建订单
					let p1 = await that.$api(`/order`, 'POST', obj);
					if (p1.errcode == '0') {
						if (system.uniPlatform == "mp-weixin") {
							// 微信支付
							uni.showLoading({
								title: '加载中'
							})
							// 支付信息
							let p2 = await that.$api('/pay/toPayOrder', 'POST', {
								order_id: p1.data,
								type: '0'
							})
							if (p2.errcode == '0' && p2.data.paySign) {
								uni.requestPayment({
									"provider": "wxpay",
									...p2.data,
									success: async function(res) {
										// 获取团信息
										let p3 = await that.$api('/group/getGroup', 'GET', {
											order_id: p1.data,
										})
										if (p3.errcode == '0') {
											uni.hideLoading();
											if (p3.data) {
												uni.reLaunch({
													url: `/pagesHome/group/share?id=${p3.data}`
												})
											} else {
												uni.reLaunch({
													url: `/pagesMy/order/index?status=${'1'}`
												})
											}
										} else {
											uni.showToast({
												title: p3.errmsg,
												icon: 'none'
											})
										}
									},
									fail: function(err) {
										uni.showToast({
											title: `支付失败`,
											icon: 'none'
										})
										uni.hideLoading();
										uni.reLaunch({
											url: `/pagesMy/order/index?status=${'0'}`
										})
									}
								})
							} else {
								uni.showToast({
									title: p2.errmsg,
									icon: 'none'
								})
							}
						} else if (system.uniPlatform == "app") {
							uni.requestPayment({
								provider: 'alipay',
								orderInfo: 'orderInfo',
								success: function(res) {
									console.log('success:' + JSON.stringify(res));
								},
								fail: function(err) {
									console.log('fail:' + JSON.stringify(err));
								}
							});
						} else {
							uni.showToast({
								title: `平台不支持支付`,
								icon: 'none'
							})
						}
					} else {
						uni.showToast({
							title: p1.errmsg,
							icon: 'none'
						})
					}
				} else {
					uni.showToast({
						title: `没有收货地址`,
						icon: 'none'
					})
				}
			},

			async computedTotal() {
				const total_detail = this.total_detail;
				let total = this.$plus(total_detail.freight_total, total_detail.goods_total)
				if (this.coupon.length > 0) {
					let discount = 0;
					for (const coupon of this.coupon) {
						const r = this.couponList.find(f => f._id === coupon)
						if (!r) continue;
						const {
							discount_config,
							discount_type
						} = r;
						if (discount_type === 'min') {
							const min = discount_config.min;
							discount = this.$plus(discount, min)
						} else if (discount_type === 'discount') {
							const min = discount_config.min || 0;
							let discount_money = 0;
							const max = discount_config.max || 0;
							// TODO 现在是平台发放的优惠券,所以可以直接用总价*折扣,如果是店铺的折扣券,则需要将金额分开,对应店铺计算折扣
							// const dm = min / 10 * total;
							const dm = this.$multiply(this.divide(min, 10), total)
							if (max !== 0) {
								if (max > dm) discount_money = dm;
								else discount_money = max
							}
							discount += discount_money
						}
					}
					total = this.$minus(total, discount)
				}
				if (total >= 0) {
					this.$set(this, `goods_total`, total);
				} else {
					uni.showToast({
						title: `实付金额不能为负数 不能使用该优惠劵`,
						icon: 'none'
					})
				}
			}
		}
	}
</script>

<style lang="scss">
	.main {
		display: flex;
		flex-direction: column;
		width: 100vw;
		height: 100vh;

		.one {
			position: relative;
			flex-grow: 1;
			background-color: var(--f1Color);

			.one_1 {
				display: flex;
				justify-content: space-between;
				align-items: center;
				width: 100vw;
				padding: 2vw;
				border-bottom: 1vw dashed var(--fcColor);

				.address {
					flex-grow: 1;
					margin: 0 0 0 2vw;
					font-size: var(--font14Size);
					color: var(--f85Color);
				}

				.iconfont {
					font-size: var(--font20Szie);
				}

				.other {
					width: 82vw;
					padding: 0 2vw;

					.name {
						font-size: var(--font16Size);
					}

					.other_1 {
						font-size: var(--font14Size);
						color: var(--f85Color);

						text {
							margin: 0 1vw 0 0;
						}
					}
				}
			}

			.one_2 {
				margin: 2vw 0 0 0;

				.list {
					width: 100vw;
					margin: 2vw 0;

					.list_1 {
						padding: 2vw;
						background-color: var(--mainColor);
						border-bottom: 0.1vw solid var(--fcColor);

						text {
							padding: 0 0 0 1vw;
						}
					}

					.list_2 {
						padding: 2vw;
						display: flex;
						background-color: var(--mainColor);

						.l {
							width: 20vw;

							.image {
								width: 100%;
								height: 20vw;
								border-radius: 5px;
							}
						}

						.c {
							width: 60vw;
							padding: 0 2vw;

							.Spec {
								font-size: var(--font12Size);
								color: var(--f85Color);
							}
						}

						.r {
							width: 15vw;
							text-align: right;
						}
					}

					.list_3 {
						width: 96vw;
						padding: 2vw;
						background-color: var(--mainColor);

						.other {
							display: flex;
							justify-content: space-between;
							border-bottom: 0.1vw solid var(--fcColor);
							margin: 0 0 2vw 0;
							padding: 2vw 0;

							.other_1 {
								font-size: var(--font16Size);
								color: var(--f85Color);
							}

							.other_3 {
								flex-grow: 1;
								margin: 0 0 0 2vw;
								font-size: var(--font12Size);
							}

							text {
								padding: 0 1vw 0 0;
								font-size: var(--font20Szie);
							}
						}
					}
				}

				.other {
					display: flex;
					justify-content: space-between;
					background-color: var(--mainColor);
					border-bottom: 0.1vw solid var(--fcColor);
					margin: 0 0 2vw 0;
					width: 96vw;
					padding: 2vw;

					.other_1 {
						font-size: var(--font16Size);
						color: var(--f85Color);
					}

					.other_3 {
						flex-grow: 1;
						margin: 0 0 0 2vw;
						font-size: var(--font12Size);
					}

					text {
						padding: 0 1vw 0 0;
						font-size: var(--font20Szie);
					}
				}
			}
		}

		.two {
			display: flex;
			justify-content: space-between;
			border-top: 0.1vw solid var(--fcColor);

			.two_1 {
				display: flex;
				align-items: center;
				padding: 0 2vw;
				font-size: var(--font16Size);

				view:last-child {
					margin: 0 0 0 2vw;
					color: var(--ff0Color);
					font-weight: bold;
				}
			}

			.two_2 {
				padding: 3vw 4vw;
				color: var(--mainColor);
				font-size: var(--font16Size);
				background-color: var(--ff0Color);
			}
		}
	}

	.scroll-view {
		position: absolute;
		top: 0;
		left: 0;
		right: 0;
		bottom: 0;

		.list-scroll-view {
			display: flex;
			flex-direction: row;
			flex-wrap: wrap;
		}
	}

	.popup {
		display: flex;
		flex-direction: column;
		height: 100vw;
		overflow-x: hidden;
		background-color: var(--f5Color);
		padding: 2vw;

		.list {
			.one {
				display: flex;
				justify-content: space-between;
				margin: 2vw 0 0 0;
				padding: 2vw;
				background-color: var(--mainColor);

				.name {
					font-size: var(--font16Size);
				}

				.address {
					font-size: var(--font14Size);
				}

				.iconfont {
					line-height: 15vw;
					font-size: var(--font20Szie);
				}
			}

			.two {
				display: flex;
				justify-content: space-between;
				border-top: 0.1vw solid var(--fcColor);
				padding: 2vw;
				background-color: var(--mainColor);
				font-size: var(--font14Size);

				.text {
					margin: 0 2vw 0 0;
					border: 0.1vw solid var(--fFB1Color);
					padding: 1vw;
					font-size: var(--font12Size);
					border-radius: 2vw;
					color: var(--fFB1Color);
				}
			}
		}
	}
</style>
